#!/usr/bin/env python

"""FlyEdit 1.0 beta 9

Copyright (c) 2001-2002 by limodou(chatme@263.net)

Version 1.0 beta 9 $Date: 2001/11/02 02:07:56 $

This a editor. Your can write your plugins which can be used in the program.

This program is free software; you can redistribute and/or modify them under the 
terms of the GNU General Public License as published by the Free Software 
Foundation; either version 2 of the License, or (at your option) any later version. 
A copy of the license is included in GNU General Public License.

$Id: flyedit.pyw,v 1.5 2001/11/02 02:07:56 lyh Exp $
"""

from Tkinter import *
import tkMessageBox
import tkSimpleDialog
import tkFileDialog 
import tkMessageBox
import sys, os

class EditError(Exception):pass
class EditAcceError(EditError):pass

class Editor:
    from Percolator import Percolator
    #from undodelegator import LineUndoDelegator
    from UndoDelegator import UndoDelegator
    from ColorDelegator import ColorDelegator
    from MultiStatusBar import MultiStatusBar

    eventlist=[]
    keylist={}
    menulist=[]
    rmenulist=[]
    initlist=[]
    toolbuttonlist=[]

    def __init__(self, root, filename=None, windowlist=None):
        self.about_title="FlyEdit 1.0(beta)"
        self.about_text="FlyEdit\nVersion 1.0(beta)\nCopyright (c) 2001-2002, limodou(chatme@263.net)"
        self.wlist=windowlist
        if not self.wlist:
            root.withdraw()

        self.ini=ini

        self.filetypes=[
                    ('Python source', '*.py *.pyw'),
                    ('Text files', '*.txt *.ini'),
                    ('All files', '*')
                ]
        self.initdir=ini.get('enviroment', 'initdir', os.getcwd())

        self.tk=root

        self.root=Toplevel(root)
        self.filename=filename

        self.root.protocol("WM_DELETE_WINDOW", self.close)    #add quit message

        self.initscreen()   #initialize the screen

        self.bindevent()    #bind event, must head makemenu

        self.makemenu()     #initialize the menu

        self.bindkeys()     #bind keys

        self.binding_status_bar()   #binding must be the last

        #run inits
        for f in self.initlist:
            f(self)

        self.per = per = self.Percolator(self.text)

        #color-begin
#        if self.ispythonsource(filename):
#            self.color = color = self.ColorDelegator()
#            per.insertfilter(color)
#        else:
#            self.color = None
#        #color-end
        self.color=None
            
        #self.undo = undo = self.LineUndoDelegator(self.text, self.vbar)
        self.undo = undo = self.UndoDelegator()
        per.insertfilter(undo)

        self.text.undo_block_start = undo.undo_block_start
        self.text.undo_block_stop = undo.undo_block_stop
        undo.set_saved_change_hook(self.saved_change_hook)

        self.open_file(filename)

        if self.wlist:
            self.wlist.add(self)

    def initscreen(self):
        root=self.root
        self.tool_frame=tool_frame=Frame(root, bd=1, relief=SUNKEN)
        tool_frame.pack(side=TOP, fill=X)

        self.text_frame=text_frame=Frame(root, height=300, width=400, relief=SUNKEN, bd=1)  #create frame

        self.text=text=Text(text_frame, wrap="word", relief=FLAT, exportselection=0) #create text widget

        self.vbar = vbar = Scrollbar(root, command=text.yview)    #create scrollbar
        #self.hbar = hbar = Scrollbar(root, command=text.xview, orient=HORIZONTAL)

        self.set_status_bar()

        vbar.pack(side=RIGHT, fill=Y)
        #hbar.pack(side=BOTTOM, fill=X)

        self.maketoolbuttons()

        text_frame.pack(side=LEFT, fill=BOTH, expand=1)
        text.pack(side=RIGHT, fill=BOTH, expand=1)
        
        text['yscrollcommand'] = vbar.set   #hook scroll event
        #text['xscrollcommand'] = hbar.set

        #how to judge in chinese or english
        if sys.platform == 'win32':
            text['font']='', 9

        text.focus_set()

    def maketoolbuttons(self):
        from ImageList import ImageList
        self.imagelist=ImageList()
        i=0
        for file, event in self.toolbuttonlist:
            if file:
                self.imagelist.add(file)
                def command(event=event, root=self.text):
                    root.event_generate(event)
                Button(self.tool_frame, image=self.imagelist[i], command=command, bd=1).pack(side=LEFT)
            else:
                self.imagelist.add('image/separator.gif')
                Label(self.tool_frame, image=self.imagelist[i]).pack(side=LEFT)
            i=i+1

    def bindevent(self):
        for event, commandname in Editor.eventlist:
            command=getattr(self, commandname)
            self.text.bind(event, command)

    def makemenu(self):
        import makemenu

        Editor.menulist=makemenu.mergemenu(Editor.menulist)

        self.menu=menu=makemenu.make(self.text, Editor.menulist)
        self.root.config(menu=menu)

        self.rmenu=Menu(self.root, tearoff=0)
        makemenu.makesubmenu(self.text, self.rmenu, Editor.rmenulist)

    def bindkeys(self):
        for event, key in Editor.keylist.items():
            if key:
                apply(self.text.event_add, (event,) + tuple(key))

    def saved_change_hook(self):
        short = self.short_title()
        long = self.long_title()
        if short and long:
            title = short + " - " + long
        elif short:
            title = short
        elif long:
            title = long
        else:
            title = "Untitled"
        icon = short or long or title
        if not self.get_saved():
            title = "%s *" % title
            icon = "*%s" % icon
        self.root.wm_title(unicode(title))
        self.root.wm_iconname(unicode(icon))

    def get_saved(self):
        return self.undo.get_saved()

    def set_saved(self, flag):
        self.undo.set_saved(flag)

    def reset_undo(self):
        self.undo.reset_undo()

    def short_title(self):
        filename = self.filename
        if filename:
            filename = os.path.basename(filename)
        return filename

    def long_title(self):
        return self.filename or ""

    def maybesave(self):
        if self.get_saved():
            return "yes"

        file=self.filename or ''
        message = "Do you want to save %s before closing?" % (
            unicode(file) or "this untitled document")
        m = tkMessageBox.Message(
            title="Save On Close",
            message=message,
            icon=tkMessageBox.QUESTION,
            type=tkMessageBox.YESNOCANCEL,
            master=self.text)
        reply = m.show()
        if reply == "yes":
            self.on_file_save(None)
            if not self.get_saved():
                reply = "cancel"
        self.text.focus_set()
        return reply

    def writefile(self, filename):
        try:
            f = open(filename, "w")
            chars = self.text.get("1.0", "end-1c")
            f.write(chars)
            f.close()
            return 1
        except IOError, msg:
            self.showmessage(str(msg))
            return 0

    def on_file_save(self, event):
        if not self.filename:
            self.on_file_saveas(event)
        else:
            if self.writefile(self.filename):
                self.set_saved(1)
        self.text.focus_set()
        return "break"

    def on_file_saveas(self, event):
        self.filename=filename=tkFileDialog.asksaveasfilename(filetypes=self.filetypes)
        if filename:
            if self.writefile(filename):
                self.change_filename(filename)
                self.set_saved(1)
        self.text.focus_set()
        return "break"

    def close(self):
        reply = self.maybesave()
        if reply != "cancel":
            self._close()
        return reply

    def _close(self):
        self.undo=None
        if self.color:
            self.color.close()
        self.text = None
        self.per.close()
        self.per = None
        self.root.destroy()
        if self.wlist:
            self.wlist.deletewin(self)
        else:
            self.tk.destroy()

    def set_status_bar(self):
        frame=Frame(self.root)
        frame.pack(side=BOTTOM, fill=X)
        self.statusbar=s=self.MultiStatusBar(frame)
        s.set_label('column', ' Col: ', side=RIGHT)
        s.set_label('line', ' Ln: ', side=RIGHT)
        s.pack(fill=X)

    def binding_status_bar(self):
        self.text.bind('<KeyRelease>', self.set_line_and_column)
        self.text.bind('<ButtonRelease>', self.set_line_and_column)
        self.text.after_idle(self.set_line_and_column)

    def set_line_and_column(self, event=None):
        line, column=self.text.index(INSERT).split('.')
        self.statusbar.set_label('column', ' Col: %s ' % (column,))
        self.statusbar.set_label('line', ' Ln: %s ' % (line,))

    def get_select(self):
        try:
            first = self.text.index("sel.first")
            last = self.text.index("sel.last")
            return first, last
        except TclError:
            return None, None

    def set_select(self, start, end):
        self.text.tag_remove(SEL, "1.0", END)
        self.text.tag_add(SEL, start, end)
        
    def get_select_text(self):
        first, last=self.get_select()
        if first:
            return self.text.get(first, last)
        else:
            return None

    def set_select_text(self, text):
        self.text.undo_block_start()
        first, last=self.get_select()
        if first:
            self.text.delete(first, last)
            self.dselect()
        self.text.insert(INSERT, unicode(text))
        self.text.see(INSERT)
        self.set_line_and_column()
        self.text.undo_block_stop()

    def dselect(self):
        self.text.tag_remove(SEL, '1.0', END)

    def get_region(self):
        text = self.text
        first, last = self.get_select()
        if first and last:
            head = text.index(first + " linestart")
            tail = text.index(last + "-1c lineend +1c")
        else:
            head = text.index("insert linestart")
            tail = text.index("insert lineend +1c")
        chars = text.get(head, tail)
        lines = chars.split("\n")
        return head, tail, chars, lines

    def set_region(self, head, tail, chars, lines):
        text = self.text
        newchars = '\n'.join(lines)
        if newchars == chars:
            text.bell()
            return
        text.tag_remove("sel", "1.0", "end")
        text.mark_set("insert", head)
        text.undo_block_start()
        text.delete(head, tail)
        text.insert(head, newchars)
        text.undo_block_stop()
        text.tag_add("sel", head, "insert")

#----------------------------------------------------------------------------------------------
#  event definition
#----------------------------------------------------------------------------------------------
    def on_file_open(self, event=None):
        reply = self.maybesave()
        if reply != "cancel":
            file=tkFileDialog.askopenfilename(filetypes=self.filetypes,initialdir =self.initdir)
            self.open_file(file)
            import os.path
            self.initdir=os.path.dirname(file)
            ini.set('enviroment', 'initdir', self.initdir)
        return "break"

    def change_filename(self, file):
        #add 2001.09.29
        if file: self.recent_add(file)
        self.filename=file
        self.changecolorizer()
        self.saved_change_hook()
        if self.wlist:
            self.wlist.change(self)

    def open_file(self, file):
        self.change_filename(file)
        if file :
            try:
                txt=open(file).read()
            except Exception, a:
                self.showmessage(a)
            else:
                self.text.delete("1.0", END)
                self.text.insert(END, unicode(txt))
                self.text.mark_set(INSERT, "1.0")
                self.text.see(INSERT)
                self.reset_undo()

    def on_file_new(self, event=None):
        Editor(self.tk, None, self.wlist)
        return "break"

    def on_file_close(self, event=None):
        self.close()
        return "break"

    def on_file_exit(self, event=None):
        self.close()
        return "break"

    def on_r_menu(self, event):
        self.rmenu.post(event.x_root, event.y_root)
        return "break"

    def showmessage(self, message):
        self.statusbar.set_label('text', message)
        self.text.after(3000, self.clearmessage)

    def clearmessage(self):
        self.showmessage('')

#----------------------------------------------------------------------------------------------
#  main
#----------------------------------------------------------------------------------------------
if __name__ == '__main__':
    reload(sys)
    try:
        sys.setdefaultencoding('mbcs')
    except:
        pass

    apppath=os.getcwd()
    sys.path.append(apppath)

    from inifile import IniFile
    ini=IniFile('flyedit.ini')

    if len(sys.argv)>1:
        file=sys.argv[1]
    else:
        file=None

    import register
    register.registerpackage(Editor, 'modules')
    register.registerpackage(Editor, 'plugin')
    root=Tk()

    from windowlist import windowlist
    windowlist=windowlist(root)
    Editor(root, file, windowlist)
    root.mainloop()
    sys.exit()
