import tkSimpleDialog

__all__=\
    [
        'keylist',
        'menulist',
        'eventlist',
        'toolbuttonlist',
        'on_search_find',
        'on_search_find_next',
        'on_search_replace',
        'on_search_goto_line'
    ]

keylist=\
    {
        '<<find-next>>':        ['<F3>'],
        '<<find>>':             ['<Control-f>'],
        '<<replace>>':          ['<Control-r>'],
        '<<goto-line>>':        ['<Control-g>']
    }

menulist = \
    [
        ('_Search', [
            ('Find...\tCtrl+F',     '<<find>>'),
            ('Replace...\tCtrl+R',  '<<replace>>'),
            ('Find next\tF3',       '<<find-next>>'),
            ('Go to line\tCtrl+G',  '<<goto-line>>')
         ])
    ]

eventlist = \
    [
        ('<<find>>',            'on_search_find'),
        ('<<replace>>',         'on_search_replace'),
        ('<<find-next>>',       'on_search_find_next'),
        ('<<goto-line>>',       'on_search_goto_line')
    ]

#toolbuttonlist
toolbuttonlist=\
    [
        (None, None),
        ('image/find.gif', '<<find>>')
    ]
def on_search_find(self, event):
    import SearchDialog
    SearchDialog.find(self.text)
    return "break"

def on_search_find_next(self, event):
    import SearchDialog
    SearchDialog.find_again(self.text)
    return "break"

def on_search_replace(self, event):
    import ReplaceDialog
    ReplaceDialog.replace(self.text)
    return "break"

def on_search_goto_line(self, event):
    text = self.text
    lineno = tkSimpleDialog.askinteger("Goto",
                                       "Go to line number:",
                                       parent=text)
    if lineno is None:
        return "break"
    if lineno <= 0:
        text.bell()
        return "break"
    text.mark_set("insert", "%d.0" % lineno)
    text.see("insert")
    self.set_line_and_column()
    return "break"
