import os

__all__=['addcolorizer', 'rmcolorizer', 'changecolorizer']

PY='.py'
HTML='.html'

def init(self):
    self.filetypes.insert(len(self.filetypes)-1, ('Html files', '*.htm *.html'))

def addcolorizer(self, type):
    self.per.removefilter(self.undo)
    if self.color:
        self.per.removefilter(self.color)
    if type==PY:
        self.color = self.ColorDelegator()
    elif type==HTML:
        import htmlcolor
        self.color=htmlcolor.HtmlColor()
    self.per.insertfilter(self.color)
    self.per.insertfilter(self.undo)

def rmcolorizer(self):
    if not self.color:
        return
    self.per.removefilter(self.undo)
    self.per.removefilter(self.color)
    self.color = None
    self.per.insertfilter(self.undo)

def changecolorizer(self):
    type=sourcetype(self.filename)
    if type:
        self.addcolorizer(type)
    else:
        self.rmcolorizer()



######################################################
def sourcetype(filename):
    if not filename: return PY
    base, ext = os.path.splitext(os.path.basename(filename))
    ext=os.path.normcase(ext)
    if ext in ('.py', '.pyw'):
        return PY
    elif ext in ('.htm', '.html'):
        return HTML
    else:
        return None
