#!/usr/bin/env python

__all__=['recent_add_menu', 'recent_add', 'recent_open_file']

def init(self):
    self.recentfiles=[]
    if self.ini.has_section('recentfiles'):
        ll=self.ini.options('recentfiles')
        ll.sort()
        for i in ll:
            self.recentfiles.append(self.ini.get('recentfiles', i, ''))

    filemenuindex=self.menu.index('File')
    filemenu=self.menu.entrycget(filemenuindex, 'menu')
    menuid=filemenu.split('.')[-1]
    menu=self.menu.children.get(menuid)
    self.filemenu=menu
    self.recent_add_menu()


def recent_add_menu(self):
    menu=self.filemenu
    if self.recentfiles:    #find menu
        #menu.insert(menu.index('end'), 'separator')
        i=1
        for m in self.recentfiles:
            def command(self=self, file=m):
                self.recent_open_file(file)
            menu.insert(menu.index('end'), 'command', label=unicode("%d %s" % (i, m)), command=command)
            i=i+1
        menu.insert(menu.index('end'), 'separator')

def recent_add(self, filename):
    import os.path
    filename=os.path.normpath(filename)
    if len(self.recentfiles)!=0:
        end=self.filemenu.index('end')
        begin=end-len(self.recentfiles)-1
        self.filemenu.delete(begin, end-1)
    if filename in self.recentfiles:
        self.recentfiles.remove(filename)
    self.recentfiles.insert(0, filename)
    if len(self.recentfiles)>8:
        self.recentfiles.pop()
    self.ini.remove_section('recentfiles')
    i=1
    for f in self.recentfiles:
        self.ini.set('recentfiles', str(i), f)
        i+=1
    self.recent_add_menu()
    
def recent_open_file(self, filename):
    reply = self.maybesave()
    if reply != "cancel":
        self.open_file(filename)
