#register functions to a class
def registerpackage(class_, modulename):
    module=__import__(modulename)
    if hasattr(module, '__all__'):
        for i in module.__all__:
            register(class_, modulename+'.'+i)

def register(class_, modulename):
    import types
    module=my_import(modulename)
    if hasattr(module, 'init'):
        value=getattr(module, 'init')
        class_.initlist.append(value)
    if not hasattr(module, '__all__'): return
    for name in module.__all__:
        property=getattr(module, name)
        t=type(property)
        if t in (types.DictType, types.TupleType, types.ListType):
            if hasattr(class_, name):
                value=getattr(class_, name)
                if t == types.DictType :
                    value.update(property)
                else:
                    value=value+property
            else:
                value=property
            setattr(class_, name, value)
        else:
            if hasattr(class_, name):   #exist a func
                delattr(class_, name)
            setattr(class_, name, property)

def my_import(name):
    mod = __import__(name)
    components = name.split('.')
    for comp in components[1:]:
        mod = getattr(mod, comp)
    return mod
